﻿
using System;
using Wisej.Web;
using Wisej.Web.Ext.GoogleMaps;

namespace TestAddress
{
	public partial class TestPage : Page
	{
		private GoogleMap Map = new GoogleMap();
		public string Latitude { get; private set; }
		public string Longitude { get; private set; }
		public string Distance { get; private set; }
		public string Message { get; private set; }
		public string Address { get; private set; }

		private string _lastQuery;
		private GeocoderResult[] _geocodes;

		public GeocoderResult[] Geocodes
		{
			get { return _geocodes; }
			private set
			{
				_geocodes = value;
			}
		}

		public TestPage()
		{
			InitializeComponent();
			Map.Options = ((Wisej.Core.DynamicObject)(Wisej.Core.WisejSerializer.Parse("{\"zoom\":4,\"center\":{\"lat\":0,\"lng\":0},\"mapTypeId\":\"roadmap\",\"mapTypeControlOptions" +
		"\":{\"style\":2,\"mapTypeIds\":[\"roadmap\",\"hybrid\",\"satellite\",\"terrain\"]}}")));
			Map.ApiKey = "AIzaSyDJ13giW35qbt9Qsznjy_CFqMJMQlAjoSw";
		}

		private void button1_Click(object sender, EventArgs e)
		{
			if (Longitude != "")
			{
				button1.Enabled = false;
				StaffLocation.PositionChanged -= StaffLocation_PositionChanged;
			}
		}

		private async void button2_Click(object sender, EventArgs e)
		{
			_lastQuery = $"Lat: {Latitude} Lng:{Longitude}";
			Geocodes = await Map.GetGeocodeAsync(double.Parse(Latitude), double.Parse(Longitude));

			if (Geocodes[0].IsError)
			{
				MessageBox.Show($"Received error {Geocodes[0].ResultCode}",
					"Search Error",
					MessageBoxButtons.OK,
					MessageBoxIcon.Error);
				Geocodes = null;
			}
			else
			{
				textBox1.Text = Geocodes[0].FormattedAddress;
			}
		}

		private void StaffLocation_PositionChanged(object sender, EventArgs e)
		{
			Wisej.Ext.Geolocation.Position oPosition = StaffLocation.LastPosition;
			if (oPosition != null)
			{
				Latitude = oPosition.Latitude.ToString("0.######");
				Longitude = oPosition.Longitude.ToString("0.######");
			}
			if (oPosition.ErrorMessage != null)
			{
				Message = oPosition.ErrorMessage;
			}
		}

		private void TestPage_Load(object sender, EventArgs e)
		{
			StaffLocation.ActiveWatch = true;
			StaffLocation.EnableHighAccuracy = true;
			Longitude = Latitude = "";
			StaffLocation.PositionChanged += StaffLocation_PositionChanged;
			
		}
	}
}
